//
//  MLAnalyseTableController.m
//  bmcc
//
//  Created by Matthias Lange on Sat May 29 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "MLAnalyseTableController.h"
#import "MLAnalyseTableRow.h"
#import "grammarModel.h"
#import "bmccMain.h"

@implementation MLAnalyseTableController

- (id)initWithParent:(bmccMain *)myParent
{
	self = [super init];
	if(self)
	{
		parent = myParent;
	}
	return self;
}

- (void)showAnalyseTable
{
	if(!analyseTableView)
	{
		//NSLog(@"Try to load Grammar nib file.");
		if (![NSBundle loadNibNamed:@"AnalyseTable" owner:self])
		{
			NSLog(@"Failed to load AnalyseTable.nib");
			NSBeep();
			return;
		}
	}
	[[analyseTableView window] makeKeyAndOrderFront:nil];
	
	// row contains the data for one table row, tableRows contains all rows
	NSMutableDictionary *row, *tableRows = [[NSMutableDictionary alloc] initWithCapacity: 1];
	NSArray *terminals = [[parent grammarModel] terminals];
	NSArray *nonTerminals = [[parent grammarModel] nterminals];
	int nonTerminalCount = [nonTerminals count];
	int terminalCount = [terminals count];
	int i, j;
	// create all the table columns needed
	for( i = 0; i < terminalCount; i++)
	{
		NSTableColumn *column = [[NSTableColumn alloc] initWithIdentifier: [NSString stringWithFormat: @"%i", i]];
		[[column headerCell] setStringValue: [terminals objectAtIndex: i]];
		[[column dataCell] setDrawsBackground: YES];
		[[column headerCell] setFont: [NSFont fontWithName: @"Lucida Grande" size: 10.0]];
		[[column dataCell] setFont: [NSFont fontWithName: @"Lucida Grande" size: 10.0]];
//		[column sizeToFit];
		[column bind: @"value" toObject: analyseTableArrayController
							withKeyPath: [NSString stringWithFormat: @"arrangedObjects.%i", i]
								options: nil];
		[analyseTableView addTableColumn: column];
	}
	NSArray *result = [[parent grammarModel] analyseTable];
	for(i = 0; i < nonTerminalCount; i++)
	{
		row = [[NSMutableDictionary alloc] init];
		[row setObject: [nonTerminals objectAtIndex: i] forKey: @"nonTerminal"];
		[analyseTableArrayController addObject: row];
		// insert the row into the dictionary
		[tableRows setObject: row forKey: [nonTerminals objectAtIndex: i]];
	}
	for(i = 0; i < nonTerminalCount; i++)
	{
		for(j = 0; j < terminalCount; j++)
		{
			NSMutableDictionary *tmpRow = [tableRows objectForKey: [nonTerminals objectAtIndex: i]];
			[tmpRow setObject: [[result objectAtIndex: i] objectAtIndex: j] forKey: [NSString stringWithFormat: @"%i", j]];
		}
	}
}

@end
