//
//  MLGrammarModel.h
//  bmcc
//
//  Created by Matthias Lange on Wed Jun 02 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class bmccMain;

@interface MLGrammarModel : NSObject
{
	
@private
	bmccMain *parent;
	
	NSString *_epsilonSymbol;
	NSString *_startSymbol;
	NSString *_name;
	NSString *_lexSpec;
	
	NSArray *_terminals;
	NSArray *_nonTerminals;
	NSArray *_rules;
	
	int _terminalCount, _nonTerminalCount;
}

// default constructor
- (id)initWithParent:(bmccMain *)myParent;

// accessor methods
- (NSString *)name;
- (NSString *)epsilonSymbol;
- (NSString *)startSymbol;
- (NSString *)lexSpecification;
- (NSString *)lexSpecificationLong;
- (NSArray *)terminals;
- (NSArray *)nonTerminals;
- (NSArray *)rules;
- (NSString *)terminalCount;
- (NSString *)nonTerminalCount;

// setting methods
- (void)setName:(NSString *)grammarName;
- (void)setEpsilonSymbol:(NSString *)eps;
- (void)setStartSymbol:(NSString *)start;
- (void)setLexSpecification:(NSString *)spec;
- (void)setTerminals:(NSArray *)term;
- (void)setNonTerminals:(NSArray *)nTerm;
- (void)setRules:(NSArray *)rules;
- (void)setTerminalCount:(int)i;
- (void)setNonTerminalCount:(int)i;

@end
