//
//  MLGrammarModel.m
//  bmcc
//
//  Created by Matthias Lange on Wed Jun 02 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "MLGrammarModel.h"
#import "bmccMain.h"

@implementation MLGrammarModel

- (id)init
{
    [super init];
/*    children = [[NSMutableArray alloc] init];
    data = [[NSMutableDictionary alloc] initWithCapacity: 2];
	nachEpsilon = [[NSMutableDictionary alloc] initWithCapacity: 2];
    firstMengen = [[NSMutableDictionary alloc] initWithCapacity: 2];
    followMengen = [[NSMutableDictionary alloc] initWithCapacity: 2];
    analyseTabelle = [[NSMutableArray alloc] init];*/
	return self;
}

- (id)initWithParent:(bmccMain *)myParent
{
	[self init];
	if(self)
		parent = myParent;
	return self;
}

/* accessor methods */

// return grammar name
- (NSString *)name
{
	return _name;
}

// return the grammars epsilon symbol
- (NSString *)epsilonSymbol
{
	return _epsilonSymbol;
}

// return the grammars start symbol
- (NSString *)startSymbol
{
	return _startSymbol;
}

// return the lex specification
- (NSString *)lexSpecificationLong
{
	return _lexSpec;
}

// return just the filename of the lex specification path
- (NSString *)lexSpecification
{
	NSArray *components = [_lexSpec pathComponents];
	int count = [components count];
	return [components objectAtIndex: count-1];
	[components release];
}

// return an array with the terminals
- (NSArray *)terminals
{
	return _terminals;
}

// return an array with the non terminals
- (NSArray *)nonTerminals
{
	return _nonTerminals;
}

// return an array with the grammar rules
- (NSArray *)rules
{
	return _rules;
}

// return terminal count
- (NSString *)terminalCount
{
	NSString *tmp = NSLocalizedString(@"terminals", @"The terminal string");
	return [NSString stringWithFormat: @"%i %@", _terminalCount, tmp];
	[tmp release];
}

// return non terminal count as string
- (NSString *)nonTerminalCount
{
	NSString *tmp = NSLocalizedString(@"non terminals", @"The non terminal string");
	return [NSString stringWithFormat: @"%i %@", _nonTerminalCount, tmp];
	[tmp release];
}

/* setting methods */

// set the grammar name
- (void)setName:(NSString *)grammarName
{
	_name = grammarName;
	[grammarName retain];
}

// set the epsilon symbol
- (void)setEpsilonSymbol:(NSString *)eps
{
	_epsilonSymbol = eps;
	[eps retain];
}

// set start symbol
- (void)setStartSymbol:(NSString *)start
{
	_startSymbol = start;
	[start retain];
}

// set lex specification
- (void)setLexSpecification:(NSString *)spec
{
	_lexSpec = spec;
	[spec retain];
}

// set the terminals
- (void)setTerminals:(NSArray *)term
{
	_terminals = term;
	[term retain];
}

// set non terminals
- (void)setNonTerminals:(NSArray *)nTerm
{
	_nonTerminals = nTerm;
	[nTerm retain];
}

// set rules
- (void)setRules:(NSArray *)rules
{
	_rules = rules;
	[rules retain];
}

// set terminal count
- (void)setTerminalCount:(int)i
{
	_terminalCount = i;
}

// set non terminal count
- (void)setNonTerminalCount:(int)i
{
	_nonTerminalCount = i;
}

@end
