//
//  MLGrammarRule.m
//  bmcc
//
//  Created by Matthias Lange on Wed Jun 02 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "MLGrammarRule.h"
#import "MLRuleOption.h"

//#define IsALeafNode ((id)-1)

@implementation MLGrammarRule

-(id)init
{
	children = [[NSMutableArray alloc] init];
	return self;
}

/*  ================
	accessor methods
	================
*/

// return rule name
- (NSString *)name
{
	return _name;
}

- (NSString *)syntax
{
	return _syntax;
}

- (NSString *)semantic
{
	return _semantic;
}

// return rule options
- (NSArray *)options
{
	return _options;
}

/*  ===============
	setting methods
	===============
*/

// set rule name
- (void)setName:(NSString *)name
{
	_name = name;
	[name retain];
}

//
- (void)setSyntax:(NSString *)syntax
{
	_syntax = syntax;
	[syntax retain];
}

//
- (void)setSemantic:(NSString *)semantic
{
	_semantic = semantic;
	[semantic retain];
}

// set options for this rule
- (void)setOptions:(NSArray *)opt
{
	_options = opt;
	[opt retain];
}

- (int)numberOfChildren
{
	return [_options count];
}

- (MLGrammarRule *)rootItem
{
	//if(rootItem == nil)
	//	rootItem = [[MLGrammarRule alloc] init];
	//return rootItem;
	return self;
}

- (MLRuleOption *)childAtIndex:(int)n
{
	//NSLog(@"[MLGrammarRule] asking object at index");
    return [_options objectAtIndex:n];
}

- (BOOL)expandable
{
	//NSLog(@"Count: %i", [_options count]);
    return ([_options count] > 0);	
}

- (void)addChild:(MLGrammarRule *)n
{
//	NSLog(@"Add object %@ to %@", [n name], [self name]);
    [children addObject:n];
//	NSLog(@"Count: %i", [children count]);
}

@end
