//
//  lexController.m
//  bmcc
//
//  Created by Matthias Lange on Mon Apr 26 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "MLLexController.h"
#import "bmccMain.h"
#import "MLIOController.h"
#import "lexModel.h"

@implementation MLLexController

-(id)init
{
	[super init];
	classElement = NO;
	keyword = NO;
	return self;
}

-(MLLexController *)initWithParent: (bmccMain *)parent
{
	[self init];
	keywords = [[NSMutableArray alloc] initWithCapacity: 1];
	className = [[NSMutableString alloc] init];
	myParent = parent;
	myLexModel = [myParent lexModel];
	return self;
}

-(void)parseLexFile:(NSData *)data
{
	NSXMLParser *myXmlParser;
	
	myXmlParser = [[NSXMLParser alloc] initWithData: data];
	[myXmlParser setDelegate: self];
	if(!myXmlParser)
		NSLog(@"Error creating parser for lex file.");
	if([myXmlParser parse])
		NSLog(@"Lex file OK");
	else
		NSLog(@"Lex file not OK");
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict
{
	if([elementName isEqualToString: @"class"])
	{
		classElement = YES;
		#ifdef _DEBUGLEXCONTROLLER
			NSLog(@"Class beginning found");
			NSLog((NSString *)[attributeDict valueForKey: @"name"]);
		#endif _DEBUGLEXCONTROLLER
		[className setString: (NSString *)[attributeDict valueForKey: @"name"]];
		[myLexModel addClass: (NSString *)[attributeDict valueForKey: @"name"]];
		[myLexModel addSyntax: (NSString *)[attributeDict valueForKey: @"syntax"]];
		keywords = [[NSMutableArray alloc] initWithCapacity: 1];
	}
	if([elementName isEqualToString: @"keyword"])
	{
		keyword = YES;
		tmpElementValue = [[NSMutableString alloc] init];
		#ifdef _DEBUGLEXCONTROLLER
			NSLog(@"Keyword beginning found");
		#endif _DEBUGLEXCONTROLLER
	}
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
	if([elementName isEqualToString: @"class"])
	{
		classElement = NO;
		#ifdef _DEBUGLEXCONTROLLER
			NSLog(@"Class end found");
		#endif _DEBUGLEXCONTROLLER
		[myLexModel addClass: className withKeywords: keywords];
	}
	if([elementName isEqualToString: @"keyword"])
	{
		keyword = NO;
		[keywords addObject: tmpElementValue];
		#ifdef _DEBUGLEXCONTROLLER
			NSLog(@"Keyword end found with keyword: %@", tmpElementValue);
		#endif _DEBUGLEXCONTROLLER
	}
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
	if(classElement && keyword)
	{
		#ifdef _DEBUGLEXCONTROLLER
			//NSLog(string);
		#endif _DEBUGLEXCONTROLLER
		tmpElementValue = (NSMutableString *)[tmpElementValue stringByAppendingString: string];
	}
}

-(void)dealloc
{
	[className release];
	[keywords release];
}

@end
