#import "MLMorphemPanelController.h"
#import "MLMorphem.h"
#import "bmccMain.h"

@implementation MLMorphemPanelController

- (void)awakeFromNib
{
	[morphemCountTextField setStringValue: @""];
	morphemCount = 0;
}

- (void)addMorphem:(MLMorphem *)morph
{
	[morph retain];
	[morphemArrayController addObject: morph];
	morphemCount++;
	[morphemCountTextField setStringValue: [NSString stringWithFormat: @"%i Morphems found", morphemCount]];
}

- (IBAction)showMorphem:(id)sender
{
	NSArray *objects = [morphemArrayController selectedObjects];
	
	[parent showMorphem: [objects objectAtIndex: 0]];
	//NSLog(@"Count of selected objects: %i", [objects count]);
	
	//NSLog(@"[MLMorphemPanelController:] Morphem with syntax: %@ and semantik: %@ at line: %i in column: %i", [[objects objectAtIndex: 0] syntax], [[objects objectAtIndex: 0] semantik], [[objects objectAtIndex: 0] line], [[objects objectAtIndex: 0] column]);
}

- (void)reset
{
	NSRange morphemRange;
	
	morphemRange.location = 0;
	morphemRange.length = [[morphemArrayController content] count];
	[morphemArrayController removeObjectsAtArrangedObjectIndexes: [[NSIndexSet alloc] initWithIndexesInRange: morphemRange]];
	morphemCount = 0;
}

@end
