#import "MLPreferences.h"

/*
 NSFontFamilyAttribute
 NSFontNameAttribute
 NSFontFaceAttribute
 NSFontSizeAttribute
 NSFontVisibleNameAttribute
 NSFontColorAttribute
*/

@implementation MLPreferences

- (IBAction)setFont:(id)sender
{
	[[self window] makeFirstResponder:[fontNameTextField window]];
	[[NSFontManager sharedFontManager] orderFrontFontPanel: self];
	[[NSFontManager sharedFontManager] setSelectedFont:[self font] isMultiple:NO];
}

- (NSFont *)font
{
	/*NSFont *theFont;
	
	theFont=[NSFont fontWithName:[[NSUserDefaults standardUserDefaults] stringForKey:@"Font"] size:[[NSUserDefaults standardUserDefaults] floatForKey:@"Size"]];
	if (!theFont)
		theFont=[NSFont userFixedPitchFontOfSize:[[NSUserDefaults standardUserDefaults] floatForKey:@"Size"]];*/
	return _font;
}

- (void)setMyFont:(NSFont *)font
{
	_font = font;
}


- (void)changeFont:(id)sender
{
//	NSFont *font;
	
//	NSLog(@"Changed font");
	[self setFontTextField];
}

- (void)setFontTextField
{
	NSFont *font = [fontManager selectedFont];
	NSDictionary *fontAttributes = [[font fontDescriptor] fontAttributes];
	NSRange range;
	
	range.location = 0;
	range.length = [[editorTextView string] length];
	
	[self setMyFont: font];
	[editorTextView setFont: font range: range];
	//[editorTextView setNeedsDisplay:YES];
	//NSLog(@"Font name: %@", [fontAttributes objectForKey: NSFontNameAttribute]);
	[fontNameTextField setStringValue: [NSString stringWithFormat: @"%@ - %@", [fontAttributes objectForKey: NSFontNameAttribute], [fontAttributes objectForKey: NSFontSizeAttribute]]];
}

@end
