//
//  MLTextViewWithLineNumbers.m
//  bmcc
//
//  Created by Matthias Lange on Tue May 25 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "MLTextViewWithLineNumbers.h"
#import "MLTextContainer.h"

#define left_margin_width 40;

@implementation MLTextViewWithLineNumbers

-(id)init
{
	self = [super init];
	
	return self;
}

-(id)initWithFrame:(NSRect)frame
{
	if (self = [super initWithFrame:frame])
	{
		NSSize contentSize;
		MLTextContainer *linedTextContainer;

		contentSize = [[self enclosingScrollView] contentSize];
	//	NSLog(@"Content size: %i", contentSize.height);
		frame = NSMakeRect(0, 0, contentSize.width, contentSize.height);
		linedTextContainer = [[MLTextContainer allocWithZone:[self zone]] initWithContainerSize:NSMakeSize(frame.size.width, 100000)];
		
		[linedTextContainer setWidthTracksTextView:YES];
		[linedTextContainer setHeightTracksTextView:NO];
		
		[self replaceTextContainer: linedTextContainer];
		
		[linedTextContainer release];
		[self setMinSize:frame.size];
		[self setMaxSize:NSMakeSize(100000, 100000)];
		[self setHorizontallyResizable:NO];
		[self setVerticallyResizable:YES];
		[self setAutoresizingMask:NSViewWidthSizable];
		[self setAllowsUndo:YES];
		[self setFont:[NSFont fontWithName: @"Courier" size: 14]];
		
	//	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(windowDidUpdate:) name:NSWindowDidUpdateNotification object:[self window]];
	}
	return self;
}

/*- (void)windowDidUpdate:(NSNotification *)aNotification
{
	[super windowDidUpdate: aNotification];
	[self updateLayout];
}*/

-(void)drawLineNumbers 
{
	NSLog(@"drawing");
	NSMutableDictionary *attr;
	int i, j;
	NSRect r;
	NSRange aRange;
	NSString *s;
	NSLayoutManager *lm;
	
	// erase rect first 
	
	r = [self bounds];
	r.size.width = left_margin_width;
	NSEraseRect( r );
	
	attr = [[NSMutableDictionary alloc] init];
	[attr setObject:[NSFont fontWithName: @"Monaco" size: 10] forKey: NSFontAttributeName];

	[attr setObject:[NSColor blueColor] forKey: NSForegroundColorAttributeName];

	i = 0;
	j = 1;
	
	lm = [self layoutManager];
	
	for( i = -10; i <= 100; i+=10)
	{
		//NSLog(@"Drawing Rect");
	//	r = [lm lineFragmentRectForGlyphAtIndex: [lm numberOfGlyphs] effectiveRange: &aRange];
	//	i += aRange.length;
	//	s = [NSString stringWithFormat: @"%i", i+10];
	//	[s drawAtPoint: NSMakePoint(5, i+10) withAttributes: attr];
	/*	[[NSColor redColor] set];
		NSRectFill(NSMakeRect(0.0, r.origin.y, 10.0, 10.0));*/
	}
	
	i = 0;
//	NSLog(@"====================");
	while ( i < [lm numberOfGlyphs] )
	{
	//	NSLog(@"Num of glyphs: %i", [lm numberOfGlyphs]);
		r = [lm lineFragmentRectForGlyphAtIndex:i effectiveRange:&aRange];
	//	NSLog(@"Rect: %f - %f", r.origin.x, r.origin.y);
	//	NSLog(@"Range: %i - %i", aRange.location, aRange.length);
		s = [NSString stringWithFormat:@"%4d", j];
		[s drawAtPoint: NSMakePoint(5, r.origin.y) withAttributes:attr];

		
	/*	[[NSColor redColor] set];
		NSRectFill(NSMakeRect(0.0, 0.0, 10.0, 10.0));
		NSLog(@"%f", r.origin.y);*/
			
		
		s = [[self string] substringWithRange:aRange];
		i += aRange.length;
//		j += [s length];
		j++;
//		NSLog(@"s length: %i", [s length]);
//		NSLog(@"J: %i",j);
	}
	[attr release];
}

- (void)updateLayout
{
	NSLog(@"Update Layout");
	NSRect r;
	
	// do some other layout things
	
	doDrawLineNumbers = YES;
	r = [self bounds];
	r.size.width = left_margin_width;
	
	//[self display];
	[self setNeedsDisplayInRect:r avoidAdditionalLayout:NO];
} 

- (void)drawRect:(NSRect)aRect 
{
	[super drawRect:aRect];

	if ( YES )
	{
		[self drawLineNumbers];
		doDrawLineNumbers = NO;
	}
	[self 
}

@end
