//
//  STreeNode.h
//  bmcc
//
//  Created by Benjamin Dittes.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface STreeNode : NSObject
{
	NSString *_name;
	NSMutableDictionary *_entries;
	NSMutableDictionary *_children;
	STreeNode *_parent;
	int _lineNumber;
}

// default constructor
- (id)initWithParent:(STreeNode *)myParent andName: (NSString *)name;

// accessors

- (NSString *)name;
- (NSMutableDictionary *)entries;
- (NSMutableDictionary *)children;
- (STreeNode *)parent;
- (int) lineNumber;
- (void) setLineNumber: (int)newNumber;
- (BOOL) isNameDefined: (NSString *)name withTypes: (NSString *)typeStr;
- (BOOL) defineName: (NSString *)name withType: (NSString *)type;
- (STreeNode *) createChildNode: (NSString *)name;
- (NSMutableArray *) getDefinitionsWithType: (NSString *) type;
- (STreeNode *) getChildNode: (NSString *)name;
- (STreeNode *) findNode: (NSString *)name;
@end
