//
//  editorToolbarController.m
//  bmcc
//
//  Created by Matthias Lange on Sun May 09 2004.
//  Copyright (c) 2004 Benjamin Dittes & Matthias Lange. All rights reserved.
//

#import "editorToolbarController.h"
#import "bmccMain.h"


@implementation editorToolbarController

-(id)init
{
	NSImage *myImage;
	NSToolbarItem *item;
	
	toolbarBundle = [NSBundle bundleForClass:[self class]];
    imagePath = [[NSString alloc] init];
    
    toolbarItems=[[NSMutableDictionary alloc] init];
    
	toolbarName  =[[NSString alloc] initWithFormat:@"Code Editor"];
	
	// set up the toolbar items
	// lex item
	imagePath = [toolbarBundle pathForResource:@"lexicalAnalysis" ofType:@"icns"];
    myImage = [[NSImage alloc] initWithContentsOfFile: imagePath];
	item=[[NSToolbarItem alloc] initWithItemIdentifier: @"lex"];
	itemName = [[NSString alloc] initWithFormat: @"Lex analyse"];
    [item setPaletteLabel: itemName]; // name in the "Customize Toolbar" sheet
    [item setLabel: itemName]; // name for the item in the toolbar
    [item setToolTip:[NSString stringWithFormat:@"Start lexical analysis"]]; // tooltip
    [item setTarget:self];
	// what should happen when it's clicked
    [item setAction:@selector(lexicalAnalysis)];
    [item setImage: myImage];
    // add to toolbar list
    [toolbarItems setObject: item forKey: @"lex"];
	
	// syntax analyse item
	imagePath = [toolbarBundle pathForResource:@"syntaxAnalysis" ofType:@"icns"];
    myImage = [[NSImage alloc] initWithContentsOfFile: imagePath];
	item=[[NSToolbarItem alloc] initWithItemIdentifier: @"syntaxAnalysis"];
	itemName = [[NSString alloc] initWithFormat: @"Syntax Analysis"];
    [item setPaletteLabel: itemName]; // name in the "Customize Toolbar" sheet
    [item setLabel: itemName]; // name for the item in the toolbar
    [item setToolTip:[NSString stringWithFormat:@"Start syntax analysis"]]; // tooltip
    [item setTarget:self];
	// what should happen when it's clicked
    [item setAction:@selector(syntaxAnalysis)];
    [item setImage: myImage];
    // add to toolbar list
    [toolbarItems setObject: item forKey: @"syntaxAnalysis"];
	
	// code item
	imagePath = [toolbarBundle pathForResource:@"code" ofType:@"icns"];
    myImage = [[NSImage alloc] initWithContentsOfFile: imagePath];
	item=[[NSToolbarItem alloc] initWithItemIdentifier: @"createCode"];
	itemName = [[NSString alloc] initWithFormat: @"Create Code"];
    [item setPaletteLabel: itemName]; // name in the "Customize Toolbar" sheet
    [item setLabel: itemName]; // name for the item in the toolbar
    [item setToolTip:[NSString stringWithFormat:@"create machine code"]]; // tooltip
    [item setTarget:self];
	// what should happen when it's clicked
    [item setAction:@selector(createCode)];
    [item setImage: myImage];
    // add to toolbar list
    [toolbarItems setObject: item forKey: @"createCode"];
	
	// release used resources
	[itemName release];
	[myImage release];
	
	[item release];
    [toolbarName release];
	return self;
}

- (editorToolbarController *)initWithParent:(bmccMain *)myParent
{
	[self init];
	parent = myParent;
	return self;
}

- (void)lexicalAnalysis
{
	[parent lexicalAnalysis];
}

- (void)syntaxAnalysis
{
	[parent syntaxAnalysis:self];
}

- (void)createCode
{
	[parent createCodeComplete: self];
}

- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar itemForItemIdentifier:(NSString *)itemIdentifier willBeInsertedIntoToolbar:(BOOL)flag
{
    return [toolbarItems objectForKey:itemIdentifier];
}

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar*)toolbar
{
    return [[toolbarItems allKeys] subarrayWithRange:NSMakeRange(0,1)];
}

- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar*)toolbar
{
    return [toolbarItems allKeys];
}

- (int)count
{
    return [toolbarItems count];
}

@end
