/* grammarController */

#import <Cocoa/Cocoa.h>

@class MLGrammarModel;
@class MLGrammarRule;
@class MLRuleOption;
@class grammarModel;
@class bmccMain;
@class optionModel;

// enable debug output
//#define _DEBUGGRAMMARCONTROLLER

@interface GrammarController : NSObject
{
    IBOutlet NSPanel *grammarWindow;
	IBOutlet NSObjectController *objectController;
	IBOutlet NSOutlineView *grammarOutlineView;
	IBOutlet NSTableColumn *terminalTableColumn, *nonTerminalTableColumn;
	IBOutlet NSTextField *terminalCountTextField, *nonTerminalCountTextField;
	
@private
	MLGrammarModel *myGrammarModel;
	MLGrammarRule *grammarRule;
	MLRuleOption *ruleOption;
	NSMutableArray *options;
	NSMutableArray *grammarRules;
	
	int ruleCount, ruleNameCount;
	
	NSArrayController *terminalArrayController;
	NSArrayController *nonTerminalArrayController;
	
	grammarModel *rootNode;
	bmccMain *myParent;
	NSOpenPanel *openPanel;
	NSMutableString *currentStringValue;
	
	BOOL nterminal;
	BOOL terminal;
	BOOL rule, option, syntax, semantik;
	BOOL isSetup;
	NSString *currentRuleName, *workingDir, *tmpElementValue;
	NSMutableArray *currentOptions;
	NSMutableArray *tmpterminals;
	NSMutableArray *tmpNonTerminals;
	
	grammarModel *grammar;
	
	optionModel *model;
}

- (id)initWithParent:(bmccMain *)parent;

- (void)showGrammar;
- (void)parseGrammarFromData:(NSData *)data inDirectory: (NSString *)dir;
- (void)fillOutlineView;
//- (void)addNode;
//- (void)addNode:(NSString *)nodeName atRow:(int)row;
//- (void)addMyChild: (NSString *)child atRow:(int)row;
- (id)outlineView:(NSOutlineView *)ov child:(int)index ofItem:(id)item;
- (int)outlineView:(NSOutlineView *)ov numberOfChildrenOfItem:(id)item;
- (id)outlineView:(NSOutlineView *)ov objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;
@end
