//
//  grammarModel.h
//  bmcc
//
//  Created by Matthias Lange on Mon Apr 19 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class bmccMain;
@class STreeNode;

//#define _DEBUGGRAMMARMODEL


@interface grammarModel : NSObject
{
	
	NSMutableArray *children;
	NSMutableDictionary *data;

	NSMutableArray *nterminals;
	NSMutableArray *terminals;
	NSMutableArray *rulesList;
	NSMutableDictionary *rules;
	NSString *lexSpecFile;
	NSString *epsilon;
	
	NSString *grammarName;
	NSString *startSymbol;
	
	NSMutableDictionary *nachEpsilon, *firstMengen, *followMengen;
	NSMutableArray *analyseTabelle;
	NSMutableArray *allOptions;
	
	bmccMain *parent;
	
	STreeNode *mainNode;
	NSMutableDictionary *jmpPositions, *memDef;
	int memDefCounter;
	
	BOOL performStepOne, performStepTwo;
}

// default constructor
- (id)initWithParent:(bmccMain *)myParent;

/* Accessor methods for the data dictionary */
- (NSString *)keyValue:(NSString *)key;
- (void)setValue:(NSString *)value forKey:(NSString *)key;

/* Accessors for the children */
//- (void)addChild:(grammarModel *)n;
//- (int)childrenCount;
//- (grammarModel *)childAtIndex:(int)i;

/* Other properties */
- (BOOL)expandable;

- (void)addNTerminal:(NSString *)nterminal;
- (void)addTerminal:(NSString *)terminal;
- (void)addRuleToList:(NSString *)ruleName;
- (void)addRuleWithName:(NSString *)ruleName withOptions:(NSArray *)options;
- (void)setLexSpec:(NSString *)spec;

- (void)setEpsilonSymbol:(NSString *)eps;
- (void)setGrammarName:(NSString *)name;
- (void)setStartSymbol:(NSString *)start;

- (NSArray *) getFirstMenge: (NSString *) S;
- (NSArray *) getFollowMenge: (NSString *) S;
- (void)buildZielMengen;
- (void)buildAnalyseTabelle;
- (NSMutableArray *)analyzeMorpheme: (NSMutableArray *)morpheme;
- (NSMutableArray *) buildSemantikWithSyntax: (NSMutableArray *)syntaxTree andMorphemen: (NSMutableArray *)morpheme withPass: (int)pass;

- (NSArray *)ruleNames;
- (NSDictionary *)rules;
- (NSArray *)nterminals;
- (NSArray *)terminals;
- (NSString *)lexSpec;

- (NSString *)epsilonSymbol;
- (NSString *)grammarName;
- (NSString *)startSymbol;
- (NSMutableDictionary *)firstMengen;
- (NSMutableDictionary *)followMengen;

- (NSMutableArray *)allOptions;

- (NSArray *)analyseTable;

- (void) ShowError: (NSString *)error;


@end
