//
//  lexAnalyse.m
//  bmcc
//
//  Created by Matthias Lange on Sun May 09 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "lexAnalyse.h"
#import "bmccMain.h"
#import "lexModel.h"
#import "regexWrapper.h"
#import "MLMorphem.h"
#import "MLMorphemPanelController.h"


@implementation lexAnalyse

- (lexAnalyse *)initWithParent: (bmccMain *)myParent
{
	[super init];
	parent = myParent;
	return self;
}

- (NSMutableArray *) analysiereString: (NSString *)text withLexSpec: (lexModel *)lex
{
	NSMutableArray * reg = [[NSMutableArray alloc] init];
	NSMutableArray * erg = [[NSMutableArray alloc] init];
	NSEnumerator *classE, *keyE;
	NSString *expr;
	id cl, key;
	regexWrapper *rW;
	
	MLMorphemPanelController *mPanelController;
	mPanelController = [parent morphemPanelController];
	
	classE = [[lex classList] objectEnumerator];
	while(cl = [classE nextObject])
	{
		expr = @"(";
		keyE = [[[lex keywords] objectForKey: cl] objectEnumerator];
		while(key = [keyE nextObject])
		{
			//expr = [expr stringByAppendingString: @"["];
			expr = [expr stringByAppendingString: key];  
			expr = [expr stringByAppendingString: @"|"];  
		}
		expr = [[expr substringToIndex:[expr length]-1] stringByAppendingString: @")"];  
		#ifdef _DEBUGLEXANALYSE
			NSLog(expr);
		#endif
		rW = [[regexWrapper alloc] initWithString:expr];
		[reg addObject: rW];
	}
	int pos = 0, line = 0, posO = 0, index, length, l, i;
	unichar c;
	NSRange R;
	while(posO < [text length])
	{
		do
		{
			c=[text characterAtIndex:posO];
			if(c!=' ' && c!='\t' && c != '\n' && c!='\r')
			{
				break;
			}
			if(c=='\n')
			{
				line++;
				pos = 0;
			}
			else if(c!='\r')
				pos++;
			posO++;
		}while(posO < [text length]);
		if(posO == [text length])
			break;
		index = -1;
		length = 0;
		i = 0;
		classE = [reg objectEnumerator];
		while(rW = [classE nextObject])
		{
			
			l = [rW getLengthOfMatch:text startAt:posO];
			if(l > length)
			{
				index = i;
				length = l;
			}
			i++;
		}
		if(index==-1)
		{

			NSString *test;
			// correct the line count, because lines start at 0
			NSString *errorString = [[NSString alloc] initWithFormat: @"Error during lexical analysis in line %i at position %i.", line+1, pos];
			test = NSLocalizedString(errorString, @"");
			// show the drawer if needed
			[parent showErrorDrawer];
			[NSThread detachNewThreadSelector: @selector(showErrors:) toTarget: parent withObject: test];
			posO++;
			pos++;
			[errorString autorelease];
			continue;
		}
		MLMorphem *morphem = [[MLMorphem alloc] init];
		R.location = posO;
		R.length = length;
		if([[[lex syntaxList] objectAtIndex:index] isEqualToString:@"$"])
		{
			[morphem setSyntax: [text substringWithRange: R]];
			[morphem setSemantic: [text substringWithRange: R]];
			[morphem setLine: line+1];
			[morphem setColumn: pos+1];
			[morphem setRange: R];
		}
		else
		{
			[morphem setSyntax: [[lex syntaxList] objectAtIndex:index]];
			[morphem setSemantic: [text substringWithRange: R]];
			[morphem setLine: line+1];
			[morphem setColumn: pos+1];
			[morphem setRange: R];
		}
		// tell the controller about the new morphem
		[mPanelController addMorphem: morphem];
		[erg addObject: morphem];
		pos += length;
		posO += length;
	}
	[rW release];
	return erg;
}

@end
